clear all
% Using labjack with DLL direct calls
header='C:\Program Files\LabJack\drivers\ljackuw.h';

% libmethods('ljackuw','-full') not working
lib = 'ljackuw';
loadlibrary('ljackuw',header) %,'alias','labjack');
% libfunctionsview('labjack'); % shows the available functions

% [a1,a2,a3,a4,a5,a6,a7]=calllib('ljackuw','GetWinVersion',0,0,0,0,0,0)

% ai = analoginput('nidaq',1); for compatible HW

idnum = int32(-1);
p1 = libpointer('int32Ptr', idnum);

stateIO = [int32(0),int32(0),int32(0),int32(0)];
p2 = libpointer('int32Ptr', stateIO);

channel = [int32(0),int32(1),int32(2),int32(3)];
p3=libpointer('int32Ptr',channel);

gain = [int32(0),int32(0),int32(0),int32(0)];
p4 = libpointer('int32Ptr', gain);

ov = int32(0);
pov = libpointer('int32Ptr',ov);

v(1,4) = single(0); % this is to create an array of 4 single precision locations
pv = libpointer('singlePtr',v);

calllib('ljackuw','AISample',p1,0,p2,0,1,4,p3,p4,0,pov,pv)

get(pv)

pause

% calllib('ljackuw','GetDriverVersion');

% calllib('ljackuw','GetFirmwareVersion',-1);

%pause

% AIStreamStart: Starts a hardware timed continuous acquisition where data
%				  is sampled and stored in the LabJack RAM buffer, and
%				  simultaneously transferred out of the RAM buffer to the
%				  PC application.  A call to this function should be
%				  followed by periodic calls to AIStreamRead, and eventually
%				  a call to AIStreamClear.
%
%	Returns:	LabJack errorcodes or 0 for no error (I32).
%	Inputs:		*idnum		-Local ID, Serial Number, or -1 for first
%							 found (I32).
idnum = int32(-1);
pidnum = libpointer('int32Ptr', idnum);
%				demo		-Send 0 for normal operation, >0 for demo
%							 mode (I32).  Demo mode allows this function
%							 to be called without a LabJack, and does little
%							 but simulate execution time.
demo=int32(0);
%				stateIOin	-Output states for IO0-IO3 (I32).
stateIOin = int32(0); % [int32(0),int32(0),int32(0),int32(0)];
%pstateIOin = libpointer('int32Ptr', stateIOin);
%				updateIO	-If >0, state values will be written.  Otherwise, just reads are performed (I32).
updateIO=int32(0);
%				ledOn		-If >0, the LabJack LED is turned on (I32).
ledOn=int32(0);
%				numChannels -Number of channels.  1, 2, or 4 (I32).  If readCount is >0, numChannels should be 4.
numChannels=int32(1);
%				*channels	-Pointer to an array of channel commands with at least numChannels elements (I32).  Each channel
%							 command is 0-7 for SE or 8-11 for Diff.
channels = [int32(8)];
pchannels=libpointer('int32Ptr',channels);
%				*gains		-Pointer to an array of gain commands with at least numChannels elements (I32).  Gain commands
%							 are 0=1,1=2,...,7=20.  Gain only available for differential channels.
gains = [int32(4)];
pgains = libpointer('int32Ptr', gains);
%				*scanRate	-Scans acquired per second (SGL).  A scan is a reading from every channel (1,2, or 4).  The
%							 sample rate (scanRate*numChannels) must be 200-1200.
scanRate = single(200);
pscanRate = libpointer('singlePtr', scanRate);
%				disableCal	-If >0, voltages returned will be raw readings that are not corrected using calibration constants (I32).
disableCal = int32(0);
%				reserved1	-Reserved for future use.  Send 0 (I32).
reserved1 = int32(0);
%				readCount	-If >0, the counter read is returned instead of the 2nd, 3rd, and 4th channel (I32).  2nd
%							 channel is bits 0-11, 3rd channel is bits 12-23, and 4th channel is bits 24-31.
%							 Only works with firmware V1.03 or higher.
readCount = int32(1);
%	Outputs:	*idnum		-Returns the Local ID or -1 if no LabJack is
%							 found (I32).
LocalID = int32(0);
pLocalID = libpointer('int32Ptr',LocalID);
%				*scanRate	-Returns the actual scan rate, which due to clock
%							 resolution is not always exactly the same as the
%							 desired scan rate (SGL).

     calllib('ljackuw','AIStreamStart',pidnum,demo,stateIOin,updateIO,ledOn,numChannels,pchannels,pgains,pscanRate,disableCal,reserved1,readCount)
% AIStreamStart(long *idnum,long demo,long stateIOin,long updateIO,long ledOn,long numChannels,long *channels,
%               long *gains,float *scanRate,long disableCal,long reserved1,long readCount);

get(pscanRate)

pause

%scanRateOut = int32(0); % this is to create an array of 1 single precision locations
%pscanRateOut = libpointer('int32Ptr',scanRateOut);

numScans = int32(4096);
timeout = int32(1);

voltages(4096,4) = single(0); % this is to create an array of 4 single precision locations
pvoltages = libpointer('singlePtr',voltages);

stateIOout(1,4096) = int32(0); % this is to create an array of 4 single precision locations
pstateIOout = libpointer('int32Ptr',stateIOout);

reserved=int32(0);
preserved = libpointer('int32Ptr',reserved);

ljScanBacklog = int32(0);
pljScanBacklog = libpointer('int32Ptr',ljScanBacklog);

overVoltage = int32(0);
poverVoltage = libpointer('int32Ptr',overVoltage);


%for i=1:10

    calllib('ljackuw','AIStreamRead',pLocalID,numScans,timeout,pvoltages,pstateIOout,preserved,pljScanBacklog,poverVoltage,0);
%    calllib('labjack','AIStreamClear',LocalID);
%    calllib('ljackuw','BitsToVolts'
%    calllib('ljackuw','ReadMem',pidnum, 0,poverVoltage,poverVoltage,poverVoltage,poverVoltage)