% Profile data input
% ProfIn0
% Concr1Prof % Up and donw is the same (anysotropy). 80 - 20% surf. steep. and 170 - 20 asperities steep. 30 + 30  - 11 + 9  0.3 and 0.5 mm (60 - 20 0.4)
% 
% ProfInRevConcr0
% ProfInRevConcrDown0 % Up and donw is the same (anysotropy). 90 - 30% surf. 190 - 60 asperities smooth. 45 - 23 0.4 mm

% ProfInBlockUp0 % Up and donw is the same (anysotropy). 70 - 30% surf. 140 - 60 asperities smooth. 27 - 21 0.5 mm
% ProfInBlockDown0 % many spikes anysotropy within 10%

% ProfInFlat10 using tape at slow speed to measure vibrations
%ProfInFlat20
% ProfIn_ConcreteSlow_fwd1 % the gray concrete block with large holes, betw
% 20 and 60 mu the % of surface goes from 50 to 20. betw 50 and 40 0.2 mm
% holes are available
ProfIn_LapisConcrslow_fwd1 % some material have a fast drop, here it is at 35 mu by 20%!

%       ABOUT ACQUISITION
% AcqTime=-1.07+4.2933; % [s]
[SampleNum,N]=size(Pr)
AcqSpeed=100/AcqTime % [mm/s]
AcqRate=SampleNum/AcqTime

%       GEOMETRIC CALIBRATION: Heights of profile
% Acquisition is @ 12 bit, 4096 levels
% The measuring range is +- 2 mm = total 4 mm
% So the resolution is 0.9765625 micron
% The sensor output is 4 to 20 mA converted to 4 / 1000 A * 220 ohm = 0.88 V to 20/1000*220=4.4 V V=IR
% So the voltage range is 3.52 V
% The Volt to micron conversion rate is 3.52 / 4 = 0.88 V / mm
% actual resistance 216.6 ohm range 0.86656 - 4.332 = 3.46544  conversion 0.86636
% Vo
Volt2mm = 0.86636;
Profil=Volt2mm*(5-Pr(:)); % Reversing the profile so that depths are below

%       GEOMETRIC CALIBRATION: Widths of profile
% I am grabbing 100 mm between two tapes, and manually deleting what is
% out, so [mm]
HorCal = 50 / SampleNum

%       PROFILE FILTERING
% to remove unwanted spikes caused by laser spot light diffraction at edges
Spikes=0;
% close
figure
hold on
grid
for i=2:SampleNum;
    if abs(Profil(i)-Profil(i-1))>0.8;
        Spikes=Spikes+1;
        %plot(i,Profil(i),'ro');
        Profil(i)=Profil(i-1);
    end;
end;
Spikes
% plot(Profil)

% figure
% hold on
 AvgProfileHeight = mean(Profil)
 plot(Profil-AvgProfileHeight) % The clean profile, shifted to the average height
 xlabel(['Sample number [x ' num2str(HorCal) ' mm]'])
 ylabel('Surface profile [mm]')
% for i=1:SampleNum, Mia(i,1)=i;end
%plot(Mia,mean(Profil),'g-.')

% MOVING AVERAGE TO REMOVE NOISE
hold on
windowSize = 10;
Profil=filter(ones(1,windowSize)/windowSize,1,Profil); % the first 10 values are 0
%Profil2=filter(ones(1,windowSize)/windowSize,1,Profil);
plot(Profil(11:SampleNum)-AvgProfileHeight,'g-')

% looking for asperities of size MinAsperityHeight > XX mm
for SpineSize = 1 : 100
% SpineSize = 10 % used as an alternative to the for loop for a single tip size
MinAsperityHeightWidth = SpineSize /1000; % [micron] this can be refined by considering friction

AsperityNum(SpineSize)=1;
for i = 7:SampleNum-50 % offset for border problems
    k=1;
    while Profil(i+k)>=Profil(i+k-1) % added equal sign because of constant surfaces (from the elimination of spikes)
        k=k+1;
    end
    if Profil(i+k-1)-Profil(i)>MinAsperityHeightWidth % enough high to hook onto
        j=1;
        while Profil(i-j)>=Profil(i-j+1) % looking for maximum going backward   % added equal sign because of constant surfaces (from the elimination of spikes)
            j=j+1;
        end
            if (j-1)*HorCal > MinAsperityHeightWidth % enough large to fit the spine end?
                Asperity(AsperityNum(SpineSize))=(j+k-2) * HorCal; % building a vector with the width of each asperity [mm]
                   HorAsperityDistribution(SpineSize, AsperityNum(SpineSize)) = (j+k-2) * HorCal; % building a matrix with the width of each asperity
                AsperityNum(SpineSize) = AsperityNum(SpineSize)+1;
                 %plot(i-j+1:i+k-1,Profil(i-j+1:i+k-1)-AvgProfileHeight,'r-')    
            end
    end
    i=i+k;
end


HorAsperitySurf(SpineSize) = sum(Asperity(1:AsperityNum(SpineSize)-1)) ;
end % for SpineSize

%   CLIMBING STATISTICS
% plot(hist(Asperity))

%for i=1:50
 %   SpineTipSize(i)=i; %/1000;
 %end

figure

plot(HorAsperitySurf, 'r--', 'linewidth',2)
% grid
% figure
hold
plot(AsperityNum-1, 'linewidth',2)
grid
title('Probability distribution')
xlabel('Spine/Claw tip diameter [micron]')
legend('"Surface" of asperities [mm/100 mm]', 'Number of useful asperities')

figure
hold
for i=10:10:60

k=1;
while HorAsperityDistribution(i,k)>0
    k=k+1;
end

subplot(2,3, i/10)
hist(HorAsperityDistribution(i,1:k-1),20)
title(['Spine/Claw tip diameter = ' num2str(i) ' micron'])
xlabel('Hor.surface preceeding asperity [mm]')
ylabel('Occurrences')
grid
end